-- luacheck: globals app os verboseLevel

local function install(self,archive)
    app.log("Trying to extract and copy MLO.")
    self:msg("Extracting initial boot loader...")
    if not archive:exists("MLO") then
      self:msg("Update failed: MLO was not found.")
      return false
    end
    if archive:extract("MLO","0:/MLO") then
      app.log("MLO copied successfully.")
    else
      self:msg("Update failed: could not copy MLO.")
      return false
    end

    app.log("Trying to extract and copy SBL.")
    self:msg("Extracting secondary boot loader...")
    if not archive:exists("SBL") then
      self:msg("Update failed: SBL was not found.")
      return false
    end
    if archive:extract("SBL","0:/SBL") then
      app.log("SBL copied successfully.")
    else
      app.log("SBL failed to copy.")
      self:msg("Update failed: could not copy SBL.")
      return false
    end

    app.log("Trying to extract and copy kernel.")
    self:msg("Extracting kernel...")
    if not archive:exists("kernel.bin") then
      self:msg("Update failed: kernel.bin was not found.")
      return false
    end
    if archive:extract("kernel.bin","0:/kernel.bin") then
      app.log("Kernel copied successfully.")
    else
      app.log("Kernel failed to copy.")
      self:msg("Update failed: could not copy kernel.")
      return false
    end

    return true
  end

  return {
      install = install
  }